#!/bin/bash

cwd=`pwd`

python_version=`echo "import sys ; print str(sys.version_info[0])+'.'+str(sys.version_info[1])" | python`
python_dir="/python$python_version"
cwd=`pwd`



basin_bin=$cwd
basin_lib_dir="$basin_bin/lib"
path="\$basin_bin/bin"
sitepath="\$basin_bin/lib/$python_dir/site-packages"
sp="$basin_lib_dir/$python_dir/site-packages"

ipython_file=`ls $sp | grep -m 1 ipython1.*egg$`
setuptools_file=`ls $sp | grep -m 1 setuptools.*egg$`
pythonpath="\$sitepath/:\$sitepath/$ipython_file:\$sitepath/$setuptools_file:\$PYTHONPATH"


# Build an environment script for bash
echo "Building a bash environment script: scripts/basin_remote_env.sh..."
echo -e "export basin_bin=$cwd \n
export BASIN_LIB_DIR=\$basin_bin/lib \n
export PATH=$path:\$PATH \n
export sitepath=$sitepath \n
export PYTHONPATH=$pythonpath" > ./scripts/basin_remote_env.sh

# build an environment script for tcsh
echo "Building a tcsh environment script: scripts/basin_remote_env.sh..."
echo -e "setenv basin_bin $cwd \n
setenv BASIN_LIB_DIR \$basin_bin/lib \n
setenv PATH $path:\${PATH} \n
setenv sitepath $sitepath \n
setenv PYTHONPATH $pythonpath" > ./scripts/basin_remote_env.csh

echo "Remote install finished."
