# basin_testscript.py

# A short test of some function calls for basin_remote
# See basin_goldberg.py for a longer example code

import ipython1.kernel.api as kernel

rc = kernel.RemoteController(('localhost',10105))
#rc.block = False


rc.executeAll('from basin import *')

cmd = """
myData=Region("/home/user/data/zcatalog.dat")
myMask=Region("/home/user/data/zmask.dat")

ra=myData.get_attribute("ra")
dec=myData.get_attribute("dec")
z=myData.get_attribute("z")

lcdm=cosmology()

r_comoving=lcdm.redshift_to_distance(z,0,0)
r_proper=lcdm.redshift_to_distance(z,1,0)

plot(r_comoving,r_proper)


x1=Attribute()
y1=Attribute()
z1=Attribute()

equatorial_to_xyz(ra,dec,r_comoving,x1,y1,z1)
plot(x1,y1,"Scatter plot of galaxies!")
dens=compute_density(x1,y1,40)

plot(dens,"Density of galaxies!")

print(mean(x1))
print(mean(z1))
print(stdev(x1))

radec=compute_density(ra,dec,20)
plot(radec,"radec")
radec_k=fft(radec)
radec_realk=real(radec_k)
radec_imagk=imag(radec_k)
plot(radec_realk,"real")
plot(radec_imagk,"imag")

"""

rc.executeAll(cmd)

