#include "Context_wrapper.h"
#include "basin_wrapper.h"

void export_Context() {

    class_<Context>("Context")
        .def(init< >())
        .def(init<const Context&>())
        .def(init<vector<double>, vector<double>, vector<int>, Data*>())
        .def("set_n_grid_points", &Context::set_n_grid_points)
        .def("get_n_grid_points", &Context::get_n_grid_points)
        .def("set_boundary", &Context::set_boundary)
        .def("get_boundary", &Context::get_boundary)
        .def("set_LowerCorner", &Context::set_LowerCorner)
        .def("set_UpperCorner", &Context::set_UpperCorner)
        .def("get_LowerCorner", &Context::get_LowerCorner)
        .def("get_UpperCorner", &Context::get_UpperCorner)
        .def("set_parent", &Context::set_parent)
        .def("get_parentData", &Context::get_parentData_pointer, return_value_policy<reference_existing_object>())
        .def("get_parentList", &Context::get_parentList_pointer, return_value_policy<reference_existing_object>())
        .def("get_parentGrid", &Context::get_parentGrid_pointer, return_value_policy<reference_existing_object>())
	.def("get_index", &Context::get_index)
      .def("get_order_type", &Context::get_order_type)
      .def("set_order_type", &Context::set_order_type)
        ;
}
