#include "Data_wrapper.h"
#include "basin_wrapper.h"

// Some helper wrappers for interfaces that Boost Python cannot handle
boost::python::object Data_get_distribution(Data &d, string key) {
    
    boost::python::list l;

    int low, high;

    d.get_distribution(key, BASIN_ID, &low, &high);

    l.append(low);
    l.append(high);

    return l;
}

boost::python::object Data_get_distribution_index(Data &d, string key) {
    
    boost::python::list l;

    int low, high;

    d.get_distribution_index(key, BASIN_ID, &low, &high);

    l.append(low);
    l.append(high);

    return l;
}


void export_Data() {
    
    int (Data::*set_context_ptr1)(Context &c) = &Data::set_context;
    Attribute* (Data::*get_attribute_ptr1)(string key) = &Data::get_attribute_pointer;
    Attribute* (Data::*get_attribute_ptr2)(int i) = &Data::get_attribute_pointer;
    int (Data::*get_num_attributes_ptr)() = &Data::get_num_attributes;
    string (Data::*get_attribute_key_names_ptr)() = &Data::get_attribute_key_names;
    bool (Data::*change_attribute_key_ptr)(string newkey, string oldkey) = &Data::change_attribute_key;


    class_<Data>("Data")
        .def(init< >())
        .def(init<Region*>())
        .def("get_ndims", &Data::get_ndims)
        .def("get_properties", &Data::get_properties)
        .def("set_parent", &Data::set_parent)
        .def("get_parent", &Data::get_parent, return_value_policy<reference_existing_object>())
        .def("set_context", set_context_ptr1)
        .def("get_context", &Data::get_context_pointer, return_value_policy<reference_existing_object>())
        .def("get_distribution", &Data_get_distribution)
        .def("get_distribution_index", &Data_get_distribution_index)
        .def("copy_attribute", &Data::copy_attribute)
        .def("get_attribute", get_attribute_ptr1, return_value_policy<reference_existing_object>())
        .def("get_attribute", get_attribute_ptr2, return_value_policy<reference_existing_object>())
        .def("get_num_attributes", get_num_attributes_ptr)
	.def("get_attribute_key_names", get_attribute_key_names_ptr)
        .def("delete_attribute", &Data::delete_attribute)
        .def("get_attribute_size", &Data::get_attribute_size)
      .def("change_attribute_key", change_attribute_key_ptr)
      .def("set_tag",&Data::set_tag)
      .def("delete_tag",&Data::delete_tag)
      .def("get_tag",&Data::get_tag)
      .def("get_ntags",&Data::get_ntags)
      .def("get_tagname",&Data::get_tagname)
        ;
}


