#include "Function_wrapper.h"
#include "basin_wrapper.h"

void export_Function() {

    void      (function::*set_order_ptr)(int) = &function::set_order;
    void      (function::*set_type_ptr)(int) = &function::set_type;
    void      (function::*set_coeffs_ptr)(vector <double>) = &function::set_coeffs;
    double    (function::*eval_ptr1)(double) = &function::eval;
    Attribute (function::*eval_ptr2)(Attribute&) = &function::eval;
    function& (*poly_fit_ptr1)(Attribute&, Attribute&, Attribute&, int) = &poly_fit;
    function& (*poly_fit_ptr2)(Attribute&, Attribute&, int) = &poly_fit;
    function& (*poly_fit_ptr3)(vector<double>&, vector<double>&, vector<double>&, int) = &poly_fit;
    function& (*poly_fit_ptr4)(vector<double>&, vector<double>&, int) = &poly_fit;

    class_<function>("function")
        .def(init< > ())
        .def(init<int, int> ())
	.def("set_order", set_order_ptr, (arg ("myorder")))
	.def("set_type", set_type_ptr, (arg ("mytype")))
	.def("set_coeffs", set_coeffs_ptr, (arg ("coeffs")))
	.def("eval", eval_ptr1, (arg ("x")))
	.def("eval", eval_ptr2, (arg ("x")))
        ;
    def("poly_fit", poly_fit_ptr1, (arg ("x"), arg ("y"), arg ("w"), arg ("order")), 
	return_value_policy<reference_existing_object>());
    def("poly_fit", poly_fit_ptr2, (arg ("x"), arg ("y"), arg ("order")), 
	return_value_policy<reference_existing_object>());
    def("poly_fit", poly_fit_ptr3, (arg ("x"), arg ("y"), arg ("w"), arg ("order")),
	return_value_policy<reference_existing_object>());
    def("poly_fit", poly_fit_ptr4, (arg ("x"), arg ("y"), arg ("order")),
	return_value_policy<reference_existing_object>());

}
