#include "Grid_wrapper.h"
#include "basin_wrapper.h"



void export_Grid() {

    /* Function pointers for Grid class*/
    Attribute* (Grid::*Grid_get_attribute_pointer1)(string key)=&Grid::get_attribute_pointer;
    int (Grid::*Grid_add_attribute)(string key,Attribute& newVect)=&Grid::add_attribute;
    /* End pointers for Grid class*/
  
    class_<Grid, bases<Data> >("Grid")
        .def(init< >())
        .def(init<string,Region*>())
        .def(init<Region*,const vector<int>&>())
        .def(init<Geometry*,const vector<int>&>())
        .def(init<vector<int>&>())
        //.def("get_ndims", &Grid::get_ndims)
        //.def("get_attribute", Grid_get_attribute_pointer1,(arg("key")), return_value_policy<reference_existing_object>())
        //.def("get_attribute_size", &Grid::get_attribute_size,(arg("key")))  
        //.def("get_parent", &Grid::get_parent,return_value_policy<reference_existing_object>())
        .def("get_nx", &Grid::get_nx)
        .def("calculate_index", &Grid::calculate_index)
        .def("calculate_coords", &Grid::calculate_coords)
        //.def("set_parent", &Grid::set_parent,(arg("par")))
        //.def("delete_attribute", &Grid::delete_attribute,(arg("key")))
        //.def("FFT", &Grid::FFT, return_value_policy<manage_new_object>())
        .def("add_attribute", Grid_add_attribute,(arg("key"),arg("newVect")))
        ;
}
