#include "Region_wrapper.h"
#include "basin_wrapper.h"



void export_Region() {


 /* Some function pointers needed for Region class */
    Region* (Region::*Region_add_child0)()=&Region::add_child;
    bool    (Region::*Region_add_child1)(Region*) = &Region::add_child;
    Region* (Region::*Region_add_child2)(string filename,string fitsTemplate)=&Region::add_child;
    List* (Region::*Region_add_list1)(string key, int n)=&Region::add_list;
    List* (Region::*Region_add_list2)(string key, List *lNew)=&Region::add_list;
    Grid* (Region::*Region_add_grid2)(string key,Grid *gNew)=&Region::add_grid;
    int (Region::*Region_set_geometry)(int nDims, int metric, int boundary, int space, const vector<double> &llNew, const vector<double> &urNew)=&Region::set_geometry;
    bool (Region::*Region_SaveHDF5) (string) = &Region::SaveHDF5;
    bool (Region::*Region_SaveTEXT) (string) = &Region::SaveTEXT;
    void (Region::*Region_set_name) (string) = &Region::set_name;
    string (Region::*Region_get_name) () = &Region::get_name;
    string (Region::*Region_get_gridNames) () = &Region::get_gridNames;
    string (Region::*Region_get_listNames) () = &Region::get_listNames;
    bool (Region::*change_grid_key_ptr)(string newkey, string oldkey) = &Region::change_grid_key;
    bool (Region::*change_list_key_ptr)(string newkey, string oldkey) = &Region::change_list_key;
    bool (Region::*delete_child_ptr)(Region* reg) = &Region::delete_child;
    string (Region::*get_client_information_ptr)(string info, string depth) = &Region::get_client_information;
    Region* (Region::*get_child_ptr1)(string iChild) = &Region::get_child;
    Region* (Region::*get_child_ptr2)(string childName) = &Region::get_child;
    /* End of Region pointers */

    /* Begin definition of Region class */    
    class_<Region>("Region")
        .def(init< >())
        .def(init<Region*>())
        .def(init<string,optional<string> >())
	.def("SaveHDF5", Region_SaveHDF5, (arg("filename")))
	.def("SaveTEXT", Region_SaveTEXT, (arg("filename")))
        .def("add_child",Region_add_child0, return_value_policy<manage_new_object>())
        .def("add_child",Region_add_child1,(arg("child")))
        .def("add_child",Region_add_child2,(arg("filename"),arg("fitsTemplate")=""), return_value_policy<manage_new_object>())
        .def("get_parent",&Region::get_parent, return_value_policy<reference_existing_object>())
        .def("get_child", get_child_ptr1, (arg("iChild")),return_value_policy<reference_existing_object>())
        .def("get_child", get_child_ptr2, (arg("childName")),return_value_policy<reference_existing_object>())
        .def("get_nchildren",&Region::get_nchildren)
      .def("add_list",Region_add_list1,(arg("key"),arg("n")), return_value_policy<reference_existing_object>())
        .def("add_list",Region_add_list2,(arg("key"),arg("lNew")), return_value_policy<reference_existing_object>())
        .def("add_grid",Region_add_grid2,(arg("key"),arg("gNew")), return_value_policy<reference_existing_object>())
        .def("get_attribute", &Region::get_attribute_pointer, (arg("key"), arg("listkey")=""), return_value_policy<reference_existing_object>())
        .def("copy_attribute", &Region::copy_attribute, (arg("key"), arg("copy_attribute")=""))
        .def("get_list",&Region::get_list_pointer,(arg("key")="RegionList0"), return_value_policy<manage_new_object>())
        .def("get_grid",&Region::get_grid_pointer,(arg("key")="RegionGrid0"), return_value_policy<reference_existing_object>())
        .def("get_nlists",&Region::get_nlists)
        .def("get_ngrids",&Region::get_ngrids)
        .def("delete_list",&Region::delete_list,(arg("key")))
        .def("delete_grid",&Region::delete_grid,(arg("key")))
        .def("set_geometry",Region_set_geometry)
        .def("get_bound",&Region::get_bound)
        .def("get_geometry",&Region::get_geometry,return_value_policy<reference_existing_object>())
        .def("calculate_inside",&Region::calculate_inside)
	.def("get_gridNames", Region_get_gridNames)
	.def("get_listNames", Region_get_listNames)
	.def("set_name", Region_set_name, (arg("Name")))
	.def("get_name", Region_get_name)
	.def("change_grid_key", change_grid_key_ptr)
	.def("change_list_key", change_list_key_ptr)
	.def("delete_child", delete_child_ptr)
	.def("get_client_information", get_client_information_ptr, (arg ("info")="", arg ("depth")=""))
        ;

}

