#include "Transforms_wrapper.h"
#include "basin_wrapper.h"



void export_Transforms() {

  class_<ConvKernel>("ConvKernel") 
    .def(init< >())
    .def(init<Attribute&, int>())
    .def("get_element", &ConvKernel::get_element,(arg("i"),arg("j")=0,arg("k")=0))
    .def("get_nx", &ConvKernel::get_nx)
    .def("get_ndims", &ConvKernel::get_ndims)
    .def("set_element", &ConvKernel::set_element,(arg("val"),arg("i"),arg("j")=0,arg("k")=0))
    .def("set_nx", &ConvKernel::set_nx,(arg("nx")))
    .def("set_ndims", &ConvKernel::set_ndims,(arg("ndims")))
    ;
  
  /* Pointers for functions from the Transforms package*/
  Attribute (*compute_density_ptr1)(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, vector<int> &nx, vector<double>&, vector<double>&, int Smoothing)= &compute_density;
  
  Attribute (*compute_density_ptr2)(Attribute& x, Attribute& y, Attribute& z, Attribute& m, vector<int> &nx) = &compute_density;
  Attribute (*compute_density_ptr3)(Attribute& x, Attribute& y, Attribute& val3, vector<int> &nx) = &compute_density;
  Attribute (*compute_density_ptr4)(Attribute& x, Attribute& val2, vector<int> &nx) = &compute_density;
  Attribute (*compute_density_ptr5)(Attribute& x, vector<int> &nx) = &compute_density;
  Attribute (*compute_density_ptr6)(Attribute& x, Attribute& y, Attribute& val3, vector<int> &nx, vector<double>& ll,vector<double>& ur) = &compute_density;
  Attribute (*compute_density_ptr7)(Attribute& x, Attribute& val2, vector<int> &nx,vector<double>&ll, vector<double>& ur) = &compute_density;
  Attribute (*compute_density_ptr8)(Attribute& x, Attribute& val2, int nx,int ndims) = &compute_density;
  Attribute (*compute_density_ptr9)(Attribute& x, Attribute& y, Attribute& val3, int nx,int ndims) = &compute_density;
  Attribute (*compute_density_ptr10)(Attribute& x, Attribute& y, Attribute& z, Attribute& m, int nx,int ndims) = &compute_density;
  Attribute (*compute_density_ptr11)(Attribute& x, int nx) = &compute_density;
  Attribute* (*compute_density_ptr12)(List*, Grid*,string,string,string,string,string)=&compute_density;
  Attribute* (*compute_density_ptr13)(List*, Grid*,string,string,string,string)=&compute_density;
  Attribute* (*compute_density_ptr14)(List*, Grid*,string,string,string)=&compute_density;
  //3d+weight, from list
  Grid* (*compute_density_ptr15)(List*, string,string,string,string,string,vector<int>,vector<double>,
				 vector<double>)=&compute_density;
  Grid* (*compute_density_ptr16)(List*, string,string,string,string,string,vector<int>)
    =&compute_density;
  Grid* (*compute_density_ptr17)(List*, string,string,string,string,string)=&compute_density;
  //2d+weight or 3d from list
  Grid* (*compute_density_ptr18)(List*, string,string,string,string,vector<int>,vector<double>,
				 vector<double>,int)=&compute_density;
  Grid* (*compute_density_ptr19)(List*, string,string,string,string,vector<int>,int)
    =&compute_density;
  Grid* (*compute_density_ptr20)(List*, string,string,string,string,int)=&compute_density;
  //1d+weight or 2d from list
  Grid* (*compute_density_ptr21)(List*, string,string,string,vector<int>,vector<double>,
				 vector<double>,int)=&compute_density;
  Grid* (*compute_density_ptr22)(List*, string,string,string,vector<int>,int)
    =&compute_density;
  Grid* (*compute_density_ptr23)(List*, string,string,string,int)=&compute_density;
  
  // equatorial_to_xyz
  string (*equatorial_to_xyz_ptr1) (List*,string,string,string,string,string,string)=&equatorial_to_xyz;
  string (*equatorial_to_xyz_ptr2) (Attribute*, Attribute*, Attribute*,
		  Attribute*, Attribute*, Attribute*)=&equatorial_to_xyz;

  string (*xyz_to_equatorial_ptr1) (List*,string,string,string,string,string,string)=&xyz_to_equatorial;
  string (*xyz_to_equatorial_ptr2) (Attribute*, Attribute*, Attribute*,
		  Attribute*, Attribute*, Attribute*)=&xyz_to_equatorial;
  
  string (*polar_to_xy_ptr1) (List*, string, string, string, string)=&polar_to_xy;
  string (*polar_to_xy_ptr2) (Attribute*, Attribute*, Attribute*, Attribute*)=&polar_to_xy;

  string (*xy_to_polar_ptr1) (List*, string, string, string, string)=&xy_to_polar;
  string (*xy_to_polar_ptr2) (Attribute*, Attribute*, Attribute*, Attribute*)=&xy_to_polar;
  
  string (*spherical_to_xyz_ptr1) (List*, string, string, string,
		  string, string, string)=&spherical_to_xyz;
  string (*spherical_to_xyz_ptr2) (Attribute*, Attribute*, Attribute*,
		  Attribute*, Attribute*, Attribute*)=&spherical_to_xyz;

  string (*xyz_to_spherical_ptr1) (List*, string, string, string,
		  string, string, string)=&xyz_to_spherical;
  string (*xyz_to_spherical_ptr2) (Attribute*, Attribute*, Attribute*,
		  Attribute*, Attribute*, Attribute*)=&xyz_to_spherical;

  string (*cylindrical_to_xyz_ptr1) (List*, string, string, string,
		  string, string, string)=&cylindrical_to_xyz;
  string (*cylindrical_to_xyz_ptr2) (Attribute*, Attribute*, Attribute*,
		  Attribute*, Attribute*, Attribute*)=&cylindrical_to_xyz;

  string (*xyz_to_cylindrical_ptr1) (List*, string, string, string,
		  string, string, string)=&xyz_to_cylindrical;
  string (*xyz_to_cylindrical_ptr2) (Attribute*, Attribute*, Attribute*,
		  Attribute*, Attribute*, Attribute*)=&xyz_to_cylindrical;
#ifdef KERNEL_FFTW_SUPPORT
  Attribute (*fft_ptr)(Attribute&) = &fft;
#endif
  Attribute  (*convolve_ptr1)(Attribute&, ConvKernel) = &convolve;
  Attribute (*convolve_ptr2)(vector<double>, ConvKernel, vector<int>, int) = &convolve;
    

    /* End pointers from Transforms package*/
    
    /* Functions from the Transforms package*/
    def("compute_density", compute_density_ptr1, (arg("x"), arg("y"), arg("z"), arg("mass"), arg("nx"), arg("ll"), arg("ur"), arg("Smoothing")=0));
    def("compute_density", compute_density_ptr2);
    def("compute_density", compute_density_ptr3);
    def("compute_density", compute_density_ptr4);
    def("compute_density", compute_density_ptr5);
    def("compute_density", compute_density_ptr6);
    def("compute_density", compute_density_ptr7);
    def("compute_density", compute_density_ptr8, (arg("x"), arg("val2"), arg("nx")=10, arg("ndims")=2));
    def("compute_density", compute_density_ptr9, (arg("x"), arg("y"), arg("val3"), arg("nx")=10, arg("ndims")=3));
    def("compute_density", compute_density_ptr10, (arg("x"), arg("y"), arg("z"), arg("m"), arg("nx")=10, arg("ndims")=3));
    def("compute_density", compute_density_ptr11, (arg("x"), arg("nx")=10));
    def("compute_density", compute_density_ptr12,return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr13,return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr14,return_value_policy<reference_existing_object>());
    // 3d+w from list
    def("compute_density", compute_density_ptr15,return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr16,return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr17,return_value_policy<reference_existing_object>());
     // 2d+w from list
    def("compute_density", compute_density_ptr18, (arg("listptr"),arg("x"), arg("y"), arg("val3"),
						   arg("dens"),arg("nx"),arg("ll"),arg("ur"),arg("ndims")=3),
	return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr19, (arg("listptr"),arg("x"), arg("y"), arg("val3"),
						   arg("dens"),arg("nx"),arg("ndims")=3),
	return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr20,(arg("listptr"),arg("x"), arg("y"), arg("val3"),
						  arg("dens"),arg("ndims")=3),
	return_value_policy<reference_existing_object>());
    // 1d+w from list
    def("compute_density", compute_density_ptr21, (arg("listptr"),arg("x"), arg("val2"),
						   arg("dens"),arg("nx"),arg("ll"),arg("ur"),arg("ndims")=2),
	return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr22, (arg("listptr"),arg("x"), arg("val2"),
						   arg("dens"),arg("nx"),arg("ndims")=2),
	return_value_policy<reference_existing_object>());
    def("compute_density", compute_density_ptr23,(arg("listptr"),arg("x"), arg("val2"),
						  arg("dens"),arg("ndims")=2),
	return_value_policy<reference_existing_object>());

    def("equatorial_to_xyz", equatorial_to_xyz_ptr1, (arg("listptr"),arg("ra")="",arg("dec")="",
						     arg("r")="",arg("x")="x_conv",arg("y")="y_conv",
						     arg("z")="z_conv"));
    def("equatorial_to_xyz",equatorial_to_xyz_ptr2);

    def("xyz_to_equatorial", xyz_to_equatorial_ptr1, (arg("listptr"), arg("x")="", arg("y")="", arg("z")="",
			    			arg("ra")="ra_conv", arg("dec")="dec_conv", arg("r")="r_conv"));
    def("xyz_to_equatorial", xyz_to_equatorial_ptr2);

    def("polar_to_xy", polar_to_xy_ptr1, (arg("listptr"), arg("r")="", arg("theta")="",
			    			arg("x")="x_conv", arg("y")="y_conv"));
    def("polar_to_xy", polar_to_xy_ptr2);

    def("xy_to_polar", xy_to_polar_ptr1, (arg("listptr"), arg("x")="", arg("y")="",
			    			arg("r")="r_conv", arg("theta")="theta_conv"));
    def("xy_to_polar", xy_to_polar_ptr2);

    def("spherical_to_xyz", spherical_to_xyz_ptr1, (arg("listptr"), arg("rho")="", arg("theta")="", arg("phi")="",
			    			arg("x")="x_conv", arg("y")="y_conv", arg("z")="z_conv"));
    def("spherical_to_xyz", spherical_to_xyz_ptr2);

    def("xyz_to_spherical", xyz_to_spherical_ptr1, (arg("listptr"), arg("x")="", arg("y")="", arg("z")="",
			    			arg("rho")="rho_conv", arg("theta")="theta_conv", arg("phi")="phi_conv"));
    def("xyz_to_spherical", xyz_to_spherical_ptr2);

    def("cylindrical_to_xyz", cylindrical_to_xyz_ptr1, (arg("listptr"), arg("r")="", arg("theta")="", arg("zIn")="",
			    			arg("x")="x_conv", arg("y")="y_conv", arg("z")="z_conv"));
    def("cylindrical_to_xyz", cylindrical_to_xyz_ptr2);

    def("xyz_to_cylindrical", xyz_to_cylindrical_ptr1, (arg("listptr"), arg("x")="", arg("y")="", arg("zIn")="",
			    			arg("r")="r_conv", arg("theta")="theta_conv", arg("z")="z_conv"));
    def("xyz_to_cylindrical", xyz_to_cylindrical_ptr2);

    def("convolve", convolve_ptr1, (arg("attr"), arg ("ConvKernel")));
    def("convolve", convolve_ptr2);

#ifdef KERNEL_FFTW_SUPPORT
    def("fft", fft_ptr, (arg("attr_in")));
#endif
    /* End Functions from the Transforms package*/
}

