#include "basin_wrapper.h"
#include "Visit_module_wrapper.h"

void (*visit_expose_discrete_ptr1)(Attribute &x, Attribute &y, Attribute &z, Attribute &scalar, string visit_name) = &visit_expose_discrete;

void (*visit_expose_discrete_ptr2)(Attribute &x, Attribute &y, Attribute &scalar, string visit_name) = &visit_expose_discrete;

void (*visit_expose_discrete_ptr3)(List &l, string x, string y, string scalar, string visit_name) = &visit_expose_discrete;

void (*visit_expose_discrete_ptr4)(List &l, string x, string y, string z, string scalar, string visit_name) = &visit_expose_discrete;

void (*visit_expose_continuous_ptr1)(vector<double> ll, vector<double> ur, vector<int> nx, Attribute &a, string visit_name) = &visit_expose_continuous;

void (*visit_expose_continuous_ptr2)(Grid &g, string attr_name, string visit_name) = &visit_expose_continuous;

void (*visit_expose_continuous_ptr3)(Grid &g, Attribute &attr, string visit_name) = &visit_expose_continuous;

void export_Visit_module() {

    def("visit_expose_discrete", visit_expose_discrete_ptr1, (arg("x"), arg("y"), arg("z"), arg("scalar"), arg("visit_name")));
    def("visit_expose_discrete", visit_expose_discrete_ptr2, (arg("x"), arg("y"), arg("scalar"), arg("visit_name")));
    def("visit_expose_discrete", visit_expose_discrete_ptr3, (arg("l"), arg("x"), arg("y"), arg("scalar"), arg("visit_name")));
    def("visit_expose_discrete", visit_expose_discrete_ptr4, (arg("l"), arg("x"), arg("y"), arg("scalar"), arg("visit_name")));
    
    def("visit_expose_continuous", visit_expose_continuous_ptr1, (arg("ll"), arg("ur"), arg("nx"), arg("a"), arg("visit_name")));
    def("visit_expose_continuous", visit_expose_continuous_ptr2, (arg("g"), arg("attr_name"), arg("visit_name")));
    def("visit_expose_continuous", visit_expose_continuous_ptr3, (arg("g"), arg("attr"), arg("visit_name")));   

    def("visit_module_start", &visit_module_start);
    def("visit_module_join", &visit_module_join);
}



    
