#include "basin_funcs_wrapper.h"
#include "basin_wrapper.h"

boost::python::object sum_py(const Attribute& a) {
    BV1 s = sum(a);
    boost::python::object py_obj = boost::apply_visitor(get_py_object(), s.value);

    return py_obj;
}

void export_basin_funcs() {
    /**
     * General functions in the BASIN library
     */    
    Attribute (*attribute_random_v)(const vector<int> b,unsigned int seed)=&attribute_random;
    def("attribute_random",attribute_random_v,(arg("b"),arg("seed")));
    Attribute (*attribute_random2)(int b,unsigned int seed)=&attribute_random;
    def("attribute_random",attribute_random2,(arg("b"),arg("seed")));
    Attribute (*pow2)(const Attribute& a, double b) = &pow;
    def("pow",pow2,(arg("a"),arg("b")));
    Attribute (*real1)(const Attribute& a)=&real;
    def("real", real1, arg("a"));
    Attribute (*imag1)(const Attribute& a)=&imag;
    def("imag", imag1, arg("a"));
    Attribute (*log1)(const Attribute& a)=&log;
    def("log",log1,(arg("a")));
    Attribute (*log101)(const Attribute& a)=&log10;
    def("log10",log101,(arg("a")));
    Attribute (*sin1)(const Attribute& a)=&sin;
    def("sin",sin1,(arg("a")));
    Attribute (*cos1)(const Attribute& a)=&cos;
    def("cos",cos1,(arg("a")));
    Attribute (*cosh1)(const Attribute& a)=&cosh;
    def("cosh",cosh1,(arg("a")));
    Attribute (*sinh1)(const Attribute& a)=&sinh;
    def("sinh",sinh1,(arg("a")));
    Attribute (*acos1)(const Attribute& a)=&acos;
    def("acos",acos1,(arg("a")));
    Attribute (*asin1)(const Attribute& a)=&asin;
    def("asin",asin1,(arg("a")));
    Attribute (*acosh1)(const Attribute& a)=&acosh;
    def("acosh",acosh1,(arg("a")));
    Attribute (*asinh1)(const Attribute& a)=&asinh;
    def("asinh",asinh1,(arg("a")));
    Attribute (*atan1)(const Attribute& a)=&atan;
    def("atan",atan1,(arg("a")));
    Attribute (*abs1)(const Attribute& a)=&abs;
    def("abs",abs1,(arg("a")));
    Attribute (*sqrt1)(const Attribute& a)=&sqrt;
    def("sqrt",sqrt1,(arg("a")));
    Attribute (*exp1)(const Attribute& a)=&exp;
    def("exp",exp1,(arg("a")));
    Attribute (*exp101)(const Attribute& a)=&exp10;
    def("exp10",exp101,(arg("a")));
    Attribute (*sort1)(const Attribute& a)=&sort;
    def("sort",sort1,(arg("a")));
    def("index_sort",&index_sort,(arg("a")));

    void (*plot3)(Attribute& x,Attribute& y,string title)=&plot;
    def("plot",plot3,(arg("x"),arg("y"),arg("title")=""));

    void (*plot2)(Attribute& x,string title)=&plot;
    def("plot",plot2,(arg("x"),arg("title")=""));

    void (*plot4)(List*,string,string,string)=&plot;
    def("plot",plot4,(arg("listptr"),arg("var1"),arg("var2"),arg("title")=""));

    void (*plot5)(Grid*,string,string)=&plot;
    def("plot",plot5,(arg("gridptr"),arg("key")="",arg("title")=""));

    void (*plot6)(vector<double>, vector<double>, int, int, string) = &plot;
    def("plot", plot6, (arg ("x"), arg ("y"), arg ("types")=0, arg ("axes")=0, arg ("title")=""));

    void (*plot7)(vector<double>, vector<double>, vector<double>) = &plot;
    def("plot", plot7, (arg ("x"), arg ("y1"), arg ("y2")));

    def("plot_hist", &plot_hist);
    def("sum", &sum_py); 
}

