/*
 * This file contains some functions that may be useful in many places
 * within the basin remote code.
 */

#include "basin_helpers.h"



/*
 * Examines a python object to find its length attribute. It will also
 * check if this object is a standard iterable type (namely a List or Tuple).
 * If supported, it will return the length of the object. Otherwise, it returns
 * a length of 0
 */ 
int get_py_object_len(boost::python::object o) {
    int o_len = 0;

    if((PyList_Check(o.ptr()) || PyTuple_Check(o.ptr()))){
        o_len = boost::python::extract<int>(o.attr("__len__")());
    }
    
    return o_len;
}



