/***
 * File: basin_wrapper.h
 *
 * Purpose: Defines various helper functions for converting between Python 
 * data types and C++ data types. These mostly deal with going from
 * something like a Python list to a C++ std vector.
 */

#ifndef __BASIN_WRAPPER_H__
#define __BASIN_WRAPPER_H__


#include "config.h"

// Some common includes
#include <basin.h>
#include <cosmology.h>
#include <simple_plot.h>
#include <statistics.h>
#include <stellardynamics.h>
#include <transforms.h>
#include <linearalgebra.h>
#include <cosmosims.h>

#ifdef VISIT_SUPPORT
#include <visit_module.h>
#endif

#include <boost/python.hpp>
//#include <boost/python/module.hpp>
//#include <boost/python/class.hpp>
//#include <boost/python/def.hpp>

#include "basin_helpers.h"
#include "container_conversion.h"

using namespace boost::python;

/* for some reason, the compiler does not pick up
 * on the boost::python namespace inside the module
 * declaration, so I did this to make the code below
 * look a little cleaner
 */
#define arg boost::python::arg




#endif //__BASIN_WRAPPER_H__
