#!/usr/bin/perl

sub trim($)
{
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}

# Generates def/function declaration pairs from an ordinary header file
#  declaration.  
# By default, if the output is a pointer, it will return reference to
#  existing object.


print "\n\nNote: If this is part of the class declaration, put the def under\n";
print " class <blah>(\"blah\")\nand make it .def\n\n";
print "Also, the function declaration should be changed to\nblah::*funcname\n\n";

# What is the return type?
@words=split(/\s+/,$ARGV[0]);

$nargs=@ARGV;
if ($nargs > 1) {
    $idx=$ARGV[1];
} else {
    $idx="0";
}

$outtype=$words[0];

# Is it a pointer?
$ptr=0;
if ($outtype =~ '\*') {
    $ptr=1;
}
$funcname=$words[1];
@words=split(/[\(\)\,]/,$ARGV[0]);

$defstr="def(\"$funcname\",$funcname$idx,(";
$ptrstr="$outtype (*$funcname$idx)(";

# How many arguments?
$nargs=@words-2;
for ($i=1; $i <= $nargs; $i++) {
    #print "$i $words[$i]\n";
    $hasdefault=0;
    $words[$i]=trim($words[$i]);
    if ($words[$i] =~ '\=') {
	$hasdefault=1;
	@default=split(/\=/,$words[$i]);
	$defaultval=$default[1];
	@argsplit=split(/\s+/,$default[0]);
	$nwords=@argsplit;
	$argname=$argsplit[$nwords-1];
	$typename="";
	for ($j=0; $j<$nwords-1; $j++) {
	    $typename="$typename $argsplit[$j]";
	}
    } else {
	# no default value, but does it have a name?
	@argsplit=split(/\s+/,$words[$i]);
	$nwords=@argsplit;
	$nmax=$nwords-1;
	if ($argsplit[$nmax]=~ m/(string|int|List|Grid|Attribute|double|float)/) {
	    $argname="var$i";
	} else {
	    $argname=$argsplit[$nmax];
	    $nmax=$nmax-1;
	}
	$typename="";
	for ($j=0; $j<=$nmax; $j++) {
	    $typename="$typename $argsplit[$j]";
	}

    }
    #print "$typename\n";
    #print "$argname\n";
    #if ($hasdefault) { print "default= $defaultval\n";}
    $ptrstr="$ptrstr $typename $argname";
    $defstr="$defstr arg(\"$argname\")";
    if ($hasdefault) {$defstr="$defstr = $defaultval";}
    if ($i < $nargs) {
	$ptrstr="$ptrstr,";
	$defstr="$defstr,";
    } else {
	$ptrstr="$ptrstr )=&$funcname;\n";
	$defstr="$defstr)";
	if ($ptr == 1) {
	    $defstr="$defstr , return_value_policy<reference_existing_object>()";
	}
	$defstr="$defstr )";
    }

}

print "---------------------------------------------\n";
print "$ptrstr\n\n";
print "$defstr\n";
